<?php
	/*----------------------------------------------------------------------*
	 | add option page for twitwi
	 *----------------------------------------------------------------------*/
	function add_twitwi_options() {
		add_options_page('Twitwi config', 'Twitwi config', 'manage_options', 'twitwi-page-options', 'twitwi_options');  
	}
    add_action('admin_menu', 'add_twitwi_options');  

	/*----------------------------------------------------------------------*
	 | option page form for twitwi
	 *----------------------------------------------------------------------*/
	function twitwi_options() {  
		global $wp_roles;
?>  
	<div class="wrap">  
		<h2>Twitwi config</h2>  
		<form method="post" action="options.php">  
			<input type="hidden" name="action" value="update" />  
    		<input type="hidden" name="page_options" value="twitwi_consumer_key, twitwi_consumer_secret, twitwi_role_default, twitwi_register_notif, twitwi_logged_redirect, twitwi_logout_redirect, twitwi_domain_mail_default" />  
			<?php wp_nonce_field('update-options') ?>  
			<table class="form-table">
				<tbody>
					<tr>
						<th><label for="twitwi_consumer_key">Consumer Key :</label></th>
						<td>
							<input type="text" id="twitwi_consumer_key" name="twitwi_consumer_key" class="regular-text code" value="<?php echo get_option('twitwi_consumer_key');?>" />  
						</td>
					</tr>
					<tr>
						<th><label for="twitwi_consumer_secret">Consumer Secret :</label></th>
						<td>
							<input type="text" id="twitwi_consumer_secret" name="twitwi_consumer_secret" class="regular-text code" value="<?php echo get_option('twitwi_consumer_secret');?>" />  
						</td>
					</tr>
					<tr>
						<th><label for="twitwi_role_default">Rôle par défaut :</label></th>
						<td>
							<select id="twitwi_role_default" name="twitwi_role_default">
<?php
							$twitwi_role_default = get_option('twitwi_role_default');
							foreach($wp_roles->role_objects as $key=>$value) {
								$selected = ($key == $twitwi_role_default) ? " selected=\"selected\"" : "";
								echo "<option value=\"".$key."\"".$selected.">";
								echo translate_user_role(ucfirst($value->name));
								echo "</option>";
							}
?>
							</select>
						</td>
					</tr>
					<tr>
						<th><label for="twitwi_domain_mail_default">Nom de domaine par défaut pour l'email temporaire :</label></th>
						<td>
							<input type="text" id="twitwi_domain_mail_default" name="twitwi_domain_mail_default" class="regular-text code" value="<?php echo get_option('twitwi_domain_mail_default');?>" /><br />
							L'API Twitter ne permettant pas la récupération de l'adresse mail de l'utilisateur, un email temporaire sera généré pour la création du compte Wordpress.
						</td>
					</tr>
					<tr>
						<th><label for="twitwi_register_notif">Recevoir un mail à chaque création d'un utilisateur :</label></th>
						<td>
							<?php $twitwi_register_notif = get_option('twitwi_register_notif');?>
							<select id="twitwi_register_notif" name="twitwi_register_notif">
								<option value="1"<?php echo ($twitwi_register_notif == 1) ? " selected=\"selected\"" : "";?>>Oui</option>
								<option value="0"<?php echo ($twitwi_register_notif == 0) ? " selected=\"selected\"" : "";?>>Non</option>
							</select>
						</td>
					</tr>
					<tr>
						<th><label for="twitwi_logged_redirect">URL de redirection après identification :</label></th>
						<td>
							<input type="text" id="twitwi_logged_redirect" name="twitwi_logged_redirect" class="regular-text code" value="<?php echo get_option('twitwi_logged_redirect');?>" />  
							<br />
 							<em>Si vide, la personne sera redirigée vers la page précédente</em>
 						</td>
					</tr>
					<tr>
						<th><label for="twitwi_logout_redirect">URL de redirection après déconnexion :</label></th>
						<td>
							<input type="text" id="twitwi_logout_redirect" name="twitwi_logout_redirect" class="regular-text code" value="<?php echo get_option('twitwi_logout_redirect');?>" />  
							<br />
 							<em>Si vide, la personne sera redirigée vers la racine du site "/"</em>
 						</td>
					</tr>
				</tbody>
			</table>
			<p class="submit">
				<input type="submit" class="button button-primary" name="submit" value="Sauvegarder" />
			</p>  
    	</form>  
	</div>  
<?php  
}  

	/*----------------------------------------------------------------------*
	 |
	 *----------------------------------------------------------------------*/
	function twitwi_admin_enqueue_scripts() {
		wp_enqueue_script('twitwi-back', WP_PLUGIN_URL.'/twitwi/js/twitwi-back.js');
	}
	add_action('admin_enqueue_scripts', 'twitwi_admin_enqueue_scripts');

	/*----------------------------------------------------------------------*
	 |
	 *----------------------------------------------------------------------*/
	function twitwi_admin_enqueue_styles() {
		wp_enqueue_style('twitwi-back', WP_PLUGIN_URL.'/twitwi/css/twitwi-back.css');
	}
	add_action('admin_enqueue_scripts', 'twitwi_admin_enqueue_styles');
	//add_action('admin_print_styles', 'twitwi_admin_enqueue_styles');

	/*----------------------------------------------------------------------*
	 |
	 *----------------------------------------------------------------------*/
	function twitwi_enqueue_scripts() {
		//
		do_action('twitwi_hook_scripts');
		//
		wp_enqueue_script('twitwi-front', WP_PLUGIN_URL.'/twitwi/js/twitwi-front.js', array('jquery'));
	}
	add_action('wp_enqueue_scripts', 'twitwi_enqueue_scripts');

	/*----------------------------------------------------------------------*
	 |
	 *----------------------------------------------------------------------*/
	function twitwi_enqueue_styles() {
		//
		do_action('twitwi_hook_styles');
		//
		wp_enqueue_style('twitwi-front', WP_PLUGIN_URL.'/twitwi/css/twitwi-front.css');
	}
	add_action('wp_enqueue_scripts', 'twitwi_enqueue_styles');

	/*----------------------------------------------------------------------*
	 |
	 *----------------------------------------------------------------------*/
	function twitwi_wp_head() {
	?>
		<script type="text/javascript">
			// plugin
			var twitwi_ajax_url = '<?php echo WP_PLUGIN_URL;?>/twitwi/ws/';
			var WP_PLUGIN_URL = '<?php echo WP_PLUGIN_URL;?>';
		</script>
	<?php
	}
	add_action('wp_head', 'twitwi_wp_head');

	/*----------------------------------------------------------------------*
	 |
	 *----------------------------------------------------------------------*/
	function twitwi_add_scripts() {
		global $wpdb, $post;

		$scripts = get_post_meta(get_the_ID(), "add_js", 1);
		$scripts = explode("\n", $scripts);

		$indice = 0;
		foreach($scripts as $script) {
			wp_enqueue_script('twitwi-script-'.$indice, $script);
			$indice++;
		}
	}
	add_action('twitwi_hook_scripts', 'twitwi_add_scripts');

	/*----------------------------------------------------------------------*
	 |
	 *----------------------------------------------------------------------*/
	function twitwi_add_styles() {
		global $wpdb, $post;

		$styles = get_post_meta(get_the_ID(), "add_css", 1);
		$styles = explode("\n", $styles);

		$indice = 0;
		foreach($styles as $style) {
			wp_enqueue_style('twitwi-style-'.$indice, $style);
			$indice++;
		}
	}
	add_action('twitwi_hook_styles', 'twitwi_add_styles');


	/*----------------------------------------------------------------------*
	 | shortcode
	 *----------------------------------------------------------------------*/
// [bartag foo="foo-value"]
	function twitwi_sc($atts) {
		global $wpdb, $post;

		$label = "Se connecter";
		$classes = array("btn", "twitwi-btn", "connect-btn");

		extract(shortcode_atts(array(
			'id' => '',
			'label' => '',
			'class' => '',
		), $atts));

		$class = explode(' ', $class);
		foreach($class as $classname) {
			$classes[] = ltrim(rtrim($classname));
		}

		$id = (!empty($id)) ? "id=\"".$id."\"" : "";

		if (!is_user_logged_in()) {
			$content = "<button ".$id." class=\"".implode(' ', $classes)."\"><span>".$label."</span></button>";
		}
		else {
			$content = "";	
		}
		
		return $content;
	}
	add_shortcode('twitwi-btn-connect', 'twitwi_sc');

	/*----------------------------------------------------------------------*
	 | CATCH REWRITE
	 *----------------------------------------------------------------------*/
	function twitwi_rewrite_rule() {
		global $wp, $wp_rewrite;

		add_rewrite_rule(
			'twitwi/connect/?$',
			'index.php?pagename=twitwi-connect',
		'top');

		add_rewrite_rule(
			'twitwi/connected/?$',
			'index.php?pagename=twitwi-connected',
		'top');

		//
		//$wp_rewrite->flush_rules();
	}
	add_action('init', 'twitwi_rewrite_rule');

	/*----------------------------------------------------------------------*
	 | Add Query Vars
	 *----------------------------------------------------------------------*/
	function twitwi_add_query_vars($aVars) {
		$aVars[] = "twitwi_vars";
		//echo implode(', ', $aVars);
		return $aVars;
	}
	add_filter('query_vars', 'twitwi_add_query_vars');

	/*----------------------------------------------------------------------*
	 | Template redirect
	 *----------------------------------------------------------------------*/
	// http://stackoverflow.com/questions/4647604/wp-use-file-in-plugin-directory-as-custom-page-template
	function twitwi_theme_redirect() {
	    global $wp, $wp_query;

	    //
		$wp_query->is_404 = false;		
		status_header(200);

	    //
	    $plugindir = dirname( __FILE__ );
	    $plugindir = str_replace('/library', '', $plugindir);

	    // twitwi connect
	    if ($wp->query_vars['pagename'] == 'twitwi-connect') {
	        $template_filename = 'connect.php';
			$return_template = $plugindir . '/template/' . $template_filename;
	        include($return_template);
	    }
	    // twitwi connect
	    if ($wp->query_vars['pagename'] == 'twitwi-connected') {
	        $template_filename = 'connected.php';
			$return_template = $plugindir . '/template/' . $template_filename;
	        include($return_template);
	    }
	}
	add_action('template_redirect', 'twitwi_theme_redirect');

	/*----------------------------------------------------------------------*
	 | Twitwi avatar
	 *----------------------------------------------------------------------*/
	function twitwi_get_avatar($avatar, $id_or_email, $size, $default, $alt) {
		global $wpdb, $user_ID;

		if(is_numeric($id_or_email)) {
			$user_id = $id_or_email;
		}
		else if (is_string($id_or_email)) {
			$query = "SELECT `ID` FROM `$wpdb->users` WHERE `user_email` = '".$id_or_email."'";
			$user_id = $wpdb->get_var($query);
		}
		else {

		}
		if(is_numeric($size)) {
			$style = " width=\"".$size."\" height=\"".$size."\"";
			$size = array($size, $size);
		}
		else if (is_array($size)) {
			$style = " width=\"".$size[0]."\" height=\"".$size[1]."\"";
			$size = $size;
		}
		else if (is_string($size)) {
			$style = "";
			$size = $size;
		}

		$attachment_id = get_user_meta($user_id, 'twitwi_picture_imported', 1);
		if (!empty($attachment_id)) {
			$image = wp_get_attachment_image_src($attachment_id, $size);
			//echo "\$attachment_id = $attachment_id";
			$avatar = "<img src=\"".$image[0]."\"".$style." alt=\"Twitwi avatar\" class=\"avatar photo\" />";
		}

	    return $avatar;
	}
	add_filter('get_avatar', 'twitwi_get_avatar', 10, 5);


	/*----------------------------------------------------------------------*
	 | Twitwi logout
	 *----------------------------------------------------------------------*/
	function twitwi_logout() {
    	foreach($_SESSION as $key=>$value) {
    		$_SESSION[$key] = null;
    		unset($_SESSION[$key]);
    	}
	}
	add_action('wp_logout','twitwi_logout');	


	/*----------------------------------------------------------------------*
	 | Twitwi logout url
	 *----------------------------------------------------------------------*/
	function twitwi_logout_url($logout_url, $redirect = null) {
		$twitwi_logout_redirect = get_option('twitwi_logout_redirect');
		if (!empty($twitwi_logout_redirect)) {
			$_wpnonce = wp_create_nonce('log-out');
			$logout_url_new = home_url()."/wp-login.php?action=logout&redirect_to=".urlencode($twitwi_logout_redirect)."&_wpnonce=".$_wpnonce;
			return $logout_url_new;	
		}

		return $logout_url;
	}
	add_filter('logout_url', 'twitwi_logout_url');

	/*----------------------------------------------------------------------*
	 | Hook test
	 *----------------------------------------------------------------------*/
	 // function twitwi_test($vars, $vars_bis) {
	 // 	//print_r($vars);
	 // 	print_r($vars_bis);
	 // 	exit;
	 // }
	 // add_action('twitwi_user_before_update', 'twitwi_test', 10, 2);