<?php
// +------------------------------------------------------------------------+
// | @author		<xuxu.fr@gmail.com>
// | @version 		1.0 (2013/12/28) XN
// | Copyright 		(c) 2013 Xuan NGUYEN
// +------------------------------------------------------------------------+

$consumer_key = get_option('twitwi_consumer_key');
$consumer_secret = get_option('twitwi_consumer_secret');

if(isset($_GET['oauth_token'])) { 
    $connection = new TwitterOAuth($consumer_key, $consumer_secret, $_SESSION['request_token'], $_SESSION['request_token_secret']);
    $access_token = $connection->getAccessToken($_REQUEST['oauth_verifier']);
    if($access_token) {
        $connection = new TwitterOAuth($consumer_key, $consumer_secret, $access_token['oauth_token'], $access_token['oauth_token_secret']);
        $params =array();
        $params['include_entities'] = 'false';
        $content = $connection->get('account/verify_credentials',$params);

 		//
        if($content && isset($content->screen_name) && isset($content->name)) {
			//
			$args = array(
				'orderby' => 'display_name',
				'order' => 'ASC',
				'blog_id'=>1,
				'meta_key'=>'twitwi_user_id',
				'meta_value'=>$content->id
			);
			$the_query = new WP_User_Query($args);
			$users = $the_query->get_results();

			if (sizeof($users) == 0) {
				//echo "CREATION<br />";
				//
				$random_password = wp_generate_password($length = 8, $include_standard_special_chars = false);

				//
				$twitwi_domain_mail_default = get_option('twitwi_domain_mail_default');
				$twitwi_domain_mail_default = (empty($twitwi_domain_mail_default)) ? "twitwi.org" : $twitwi_domain_mail_default;

				$user_id = wp_create_user($content->screen_name, $random_password, $content->screen_name."@".$twitwi_domain_mail_default);

				//
				$twitwi_role_default = get_option('twitwi_role_default');
				$U = new WP_User($user_id);
				$U->add_role($twitwi_role_default);

				//
				do_action('twitwi_user_created', $user_id);

				// send mail
				$blogname = get_bloginfo('name');
				$mailadmin = get_bloginfo('admin_email');

				//
				$twitwi_register_notif = get_option('twitwi_register_notif');
				if (!empty($twitwi_register_notif) && $twitwi_register_notif > 0) {
					//$attachments = array( WP_CONTENT_DIR . '/uploads/file_to_attach.zip');
					$attachments = "";
					$headers = 'From: '.$blogname.' <'.$mailadmin.'>'."\r\n";
					$message = "
						<strong>Un nouvel utilisateur Twitter vient de s'inscrire.</strong><br />
						<p>Identifiant : <strong>".$content->screen_name."</strong></p>
						<p>Nom : <strong>".$content->name."</strong></p>
					";
					wp_mail($mailadmin, '['.$blogname.'] Nouvelle inscription : '.$name, $message, $headers, $attachments);
				}
			}
			else {
				//echo "USER EXIST<br />";
				$user_id = $users[0]->ID;
			}

			$params = array(
				"ID"=>$user_id,
				"last_name"=>$content->name,
				"first_name"=>"",
				"display_name"=>$content->screen_name,
				"description"=>$content->description,
			);

			//
			do_action('twitwi_user_before_update', $user_id, $params);

			//
			wp_update_user($params);

			//
		   	update_user_meta($user_id, 'twitwi_user_id', $content->id);

		   	// avatar manage
			$picture_path = $content->profile_image_url;
			$picture_path = str_replace("_normal", "", $picture_path);

			$twitwi_picture_max = get_user_meta($user_id, 'twitwi_picture_max', 1);

			//$avatar_filename = 'twitwi_avatar_'.$user_id.'_'.$content->id.'.png';
			$avatar_filename = "twitwi_".$user_id."_".$content->id."_".basename($picture_path);
			
			$upload_dir = wp_upload_dir();
			$final_url = $upload_dir['url']."/".$avatar_filename;
			$final_path = $upload_dir['path']."/".$avatar_filename;

			if (
				empty($twitwi_picture_max)
				|| (
					!empty($twitwi_picture_max) && $twitwi_picture_max != $picture_path
				)
				||
				!file_exists($final_path)
			) {			
			   	// Avatar manage
			   	$f = fopen($picture_path, 'r');
				$contents = '';
				while (!feof($f)) { $contents .= fread($f, 8192); }
				fclose($f);

			   	$f = fopen($final_path, 'w+');
			   	fwrite($f, $contents);
			   	fclose($f);

				$wp_filetype = wp_check_filetype(basename($final_path), null);
				$attachment = array(
					'guid' => $upload_dir['url'].'/'.basename($final_path), 
					'post_author' => $user_id,
					'post_type' => 'attachment',  
					'post_mime_type' => $wp_filetype['type'],
					'post_title' => preg_replace('/\.[^.]+$/', '', basename($final_path)),
					'post_content' => '',
					'post_status' => 'inherit'
				);
				$subpath = $upload_dir['subdir']."/".basename($final_path);
				$subpath = preg_replace("/^\//", "", $subpath);
				$attach_id = wp_insert_attachment($attachment, $subpath);

				// you must first include the image.php file
				// for the function wp_generate_attachment_metadata() to work
				require_once ABSPATH.'wp-admin/includes/image.php';
				$attach_data = wp_generate_attachment_metadata($attach_id, $final_path);
				wp_update_attachment_metadata($attach_id, $attach_data);

			   	update_user_meta($user_id, 'twitwi_picture_imported', $attach_id);


			   	update_user_meta($user_id, 'twitwi_picture_max', $picture_path);

				//
				do_action('twitwi_user_avatar_updated', $user_id, $attach_id);
			}

			wp_set_auth_cookie($user_id, $remember = true, $secure = '');

			//
			do_action('twitwi_user_authenticated', $user_id);

			//
			$twitwi_logged_redirect = get_option('twitwi_logged_redirect');
			if (!empty($twitwi_logged_redirect)) {
				wp_redirect($twitwi_logged_redirect);
			}
			else {
				wp_redirect(home_url());
			}
        }
        else {
			echo "NO USER FOUND :/<hr />";
        }
    }
	else {
		echo "ACCESS TOKEN INVALID.<hr />";	
	}
}
else {
	header("Location: /");
}
exit;